// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/memory_inst.hpp"



memory_inst::memory_inst( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    clk("clk"),
    rst("rst"),
    addr("addr"),
    datai("datai"),
    datao("datao"),
    irq_n("irq_n"),
    nmi_n("nmi_n"),
    sob_n("sob_n"),
    res_n("res_n"),
    rdy("rdy"),
    vpab("vpab"),
    sync("sync"),
    we_n("we_n"),
    oeb("oeb"),
    psel1("psel1"),
    psel2("psel2"),
    psel3("psel3"),
    psel4("psel4"),
    psel5("psel5"),
    psel6("psel6"),
    psel7("psel7"),
    psel8("psel8"),
    penable("penable"),
    presetn("presetn"),
    paddr("paddr"),
    pwrite("pwrite"),
    pwdata("pwdata"),
    pready("pready"),
    prdata("prdata"),
    pwdata_var(0UL),
    paddr_var(0UL),
    state("state"),
    state_sig_var(uint8_t(0U)),
    _ram(),
    _rom(),
    ram_addr(uint16_t(0U)),
    rom_addr(uint16_t(0U)),
    addr_firstbit_ram(false),
    addr_firstbit_rom(false)
{
    datai.initialize( uint8_t(0U) );
    irq_n.initialize( false );
    nmi_n.initialize( false );
    sob_n.initialize( false );
    res_n.initialize( false );
    rdy.initialize( false );
    psel1.initialize( false );
    psel2.initialize( false );
    psel3.initialize( false );
    psel4.initialize( false );
    psel5.initialize( false );
    psel6.initialize( false );
    psel7.initialize( false );
    psel8.initialize( false );
    penable.initialize( false );
    presetn.initialize( false );
    paddr.initialize( 0UL );
    pwrite.initialize( false );
    pwdata.initialize( 0UL );
    state = uint8_t(0U);
    for (int ind = 32767L; ind >= 0L; ind = ind - 1)
    {
        _ram[ind] = uint8_t(0U);
    }
    for (int ind_0 = 16383L; ind_0 >= 0L; ind_0 = ind_0 - 1)
    {
        _rom[ind_0] = uint8_t(0U);
    }

    SC_METHOD( process );
    sensitive << state;

    SC_METHOD( process_0 );
    sensitive << clk.pos();

    SC_METHOD( process_1 );
    sensitive << clk << addr;

    SC_METHOD( process_2 );
    sensitive << clk.pos();
}

memory_inst::~memory_inst()
{}

void memory_inst::start_of_simulation()
{
    state_sig_var = uint8_t(0U);
    state = state_sig_var & uint8_t(15U);
    datai = uint8_t(0U);
    irq_n = false;
    nmi_n = false;
    res_n = false;
    rdy = false;
    sob_n = false;
    psel1 = false;
    psel2 = false;
    psel3 = false;
    psel4 = false;
    psel5 = false;
    psel6 = false;
    psel7 = false;
    psel8 = false;
    penable = false;
    presetn = false;
    pwrite = false;
    paddr = 0UL;
    pwdata = 0UL;
}


void memory_inst::process()
{
    switch (state_sig_var)
    {
        case uint8_t(0U):
            rdy = false;
            sob_n = false;
            irq_n = false;
            nmi_n = false;
            res_n = false;
            break;
        case uint8_t(1U):
        case uint8_t(2U):
        case uint8_t(6U):
            rdy = true;
            sob_n = true;
            irq_n = false;
            nmi_n = false;
            res_n = false;
            break;
        case uint8_t(3U):
        case uint8_t(4U):
        case uint8_t(5U):
            rdy = true;
            sob_n = true;
            irq_n = false;
            nmi_n = true;
            res_n = false;
            break;
        case uint8_t(7U):
        case uint8_t(8U):
        case uint8_t(9U):
            rdy = true;
            sob_n = true;
            irq_n = false;
            nmi_n = false;
            res_n = true;
            break;
        default:
            break;
    }
}

void memory_inst::process_0()
{
    if (rst.read() == true)
    {
        state_sig_var = uint8_t(0U);
        state = state_sig_var & uint8_t(15U);
    }
    else
    {
        switch (state_sig_var)
        {
            case uint8_t(0U):
                state_sig_var = uint8_t(1U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(1U):
                state_sig_var = uint8_t(2U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(2U):
                state_sig_var = uint8_t(3U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(3U):
                state_sig_var = uint8_t(4U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(4U):
                state_sig_var = uint8_t(5U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(5U):
                state_sig_var = uint8_t(6U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(6U):
                state_sig_var = uint8_t(7U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(7U):
            case uint8_t(9U):
                state_sig_var = uint8_t(8U);
                state = state_sig_var & uint8_t(15U);
                break;
            case uint8_t(8U):
                state_sig_var = uint8_t(9U);
                state = state_sig_var & uint8_t(15U);
                break;
            default:
                break;
        }
    }
}

void memory_inst::process_1()
{
    ram_addr = addr.read() & uint16_t(16383U);
    rom_addr = addr.read() & uint16_t(16383U);
    addr_firstbit_ram = static_cast< uint16_t >( addr.read() >> uint16_t(15U) )
         & uint16_t(1U);
    addr_firstbit_rom = static_cast< uint16_t >( addr.read() >> uint16_t(15U) )
         & uint16_t(1U);
    if (!addr_firstbit_ram && !we_n.read())
    {
        _ram[static_cast< int32_t >( ram_addr )] = datao.read();
    }
    else if (!addr_firstbit_ram && we_n.read())
    {
        datai = _ram[static_cast< int32_t >( ram_addr )];
    }
    else if (addr_firstbit_rom && we_n.read())
    {
        datai = _rom[static_cast< int32_t >( rom_addr )];
    }
}

void memory_inst::process_2()
{
    pwdata_var = pwdata.read();
    paddr_var = paddr.read();
    psel1 = _ram[7199L] & uint8_t(1U);
    psel2 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(1U) ) & uint8_t(1U);
    psel3 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(2U) ) & uint8_t(1U);
    psel4 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(3U) ) & uint8_t(1U);
    psel5 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(4U) ) & uint8_t(1U);
    psel6 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(5U) ) & uint8_t(1U);
    psel7 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(6U) ) & uint8_t(1U);
    psel8 = static_cast< uint8_t >( _ram[7199L] >> uint8_t(7U) ) & uint8_t(1U);
    penable = _ram[7208L] & uint8_t(1U);
    presetn = static_cast< uint8_t >( _ram[7208L] >> uint8_t(1U) ) & uint8_t(1U
        );
    pwrite = static_cast< uint8_t >( _ram[7208L] >> uint8_t(2U) ) & uint8_t(1U);
    pwdata_var = pwdata_var & 16777215UL | static_cast< uint32_t >( _ram[7203L]
         ) << 24L;
    pwdata_var = pwdata_var & 4278255615UL | static_cast< uint32_t >( _ram[7202L
        ] ) << 16L;
    pwdata_var = pwdata_var & 4294902015UL | static_cast< uint32_t >( _ram[7201L
        ] ) << 8L;
    pwdata_var = pwdata_var & 4294967040UL | _ram[7200L];
    paddr_var = paddr_var & 16777215UL | static_cast< uint32_t >( _ram[7198L] )
         << 24L;
    paddr_var = paddr_var & 4278255615UL | static_cast< uint32_t >( _ram[7197L]
         ) << 16L;
    paddr_var = paddr_var & 4294902015UL | static_cast< uint32_t >( _ram[7196L]
         ) << 8L;
    paddr_var = paddr_var & 4294967040UL | _ram[7195L];
    _ram[7207L] = prdata.read() >> 24L & 255UL;
    _ram[7206L] = prdata.read() >> 16L & 255UL;
    _ram[7205L] = prdata.read() >> 8L & 255UL;
    _ram[7204L] = prdata.read();
    _ram[7208L] = pready.read() ? static_cast< uint8_t >( _ram[7208L] | uint8_t
        (8U) ) : static_cast< uint8_t >( _ram[7208L] & uint8_t(247U) );
    paddr = paddr_var;
    pwdata = pwdata_var;
}



